global plafondC;

%-----------------------------------------------------%
% Script Matlab permettant de visualiser la fonction  %
% d'imposition sur le revenu pour une personne valide %
% ou invalide. Il utilise la fonction "imposition.m"  %
%-----------------------------------------------------%

%%% Chiffres 2015 %%%

% Chiffres 2015
invalide = 1;
nombre_parts = 1 + 0.5*invalide; % une demi part supplmentaire si invalide
abattement_fiscal_min = 426;     % abattement frais professionnel minimal
abattement_fiscal_max = 12157;   % et maximal, sinon -10 %
revenu_special_min = 14710;      % fourchettes pour lesquelles est appliqu
revenu_special_max = 23700;      % un abattement spcial d'invalidit
if invalide
    abattement_special_max = 2344; % abattement spcial pour faible salaire
    abattement_special_min = 1172; % abattement spcial pour salaire moyen
else
    abattement_special_min = 0;
    abattement_special_max = 0;
end
tranche1 = 9690;  taux1 = 0;     % Les diffrentes tranches d'imposition
tranche2 = 26764; taux2 = 0.14;
tranche3 = 71754; taux3 = 0.3;
tranche4 = 151956;taux4 = 0.41;
impot_min = 1135;

%%% Calcul des points critiques %%%

if invalide 
    QF_impot_nul = impot_min/(2*nombre_parts*taux2)+tranche1;
else
    QF_impot_nul = impot_min/(2*nombre_parts*taux2)+tranche1;
    %(impot_min/(3*nombre_parts)+tranche2*(taux3-taux2)+...tranche1*taux2)/taux3;
end
salaire_impot_nul=(nombre_parts*QF_impot_nul+abattement_special_min)/(12*0.9)

salaire_tranche1fin=(nombre_parts*tranche1+abattement_special_max)/(12*0.9)
salaire_tranche2fin=(nombre_parts*tranche2)/(12*0.9)
salaire_tranche3fin=(nombre_parts*tranche3)/(12*0.9)
salaire_tranche4fin=(nombre_parts*tranche4)/(12*0.9)

QF_decote_nulle = impot_min/(nombre_parts*taux2)+tranche1;
%(impot_min/nombre_parts-(tranche2-tranche1)*taux2+... tranche2*taux3)/taux3;
salaire_decote_nulle = (nombre_parts*QF_decote_nulle+...
    abattement_special_min)/(12*0.9)

%%% Construction de la fonction d'imposition %%%

salaire_max = 8000; %salaire_tranche3fin+100; 

abs_salaires = 0:0.1:salaire_max;            % en abscisse les salaires
ord_impots = zeros(1,length(abs_salaires));  % en ordonne les impts

for i=1:length(ord_impots)
    ord_impots(i) = imposition(abs_salaires(i),invalide);
end

%%% Reprsentation graphique de la variation des impts sur le revenu %%%

figure1 = figure('Color',[1 1 1]);
if invalide
    plot(abs_salaires,ord_impots,'Color','r','LineWidth',2);
    hold on;
    a=0.269;
    b=-704;
    plot(abs_salaires,a.*abs_salaires+b);
else
    plot(abs_salaires,ord_impots,'Color','b','LineWidth',2);
    
end
hold on;
plot([salaire_impot_nul salaire_impot_nul],[0 ord_impots(end)],'--m');
plot([salaire_tranche1fin salaire_tranche1fin],[0 ord_impots(end)],'--g');
plot([salaire_tranche2fin salaire_tranche2fin],[0 ord_impots(end)],'--g');
plot([salaire_tranche3fin salaire_tranche3fin],[0 ord_impots(end)],'--g');
%plot([salaire_tranche4fin salaire_tranche4fin],[0 ord_impots(end)],'--g');
plot([salaire_decote_nulle salaire_decote_nulle],[0 ord_impots(end)],'--b');
if invalide
    plot([revenu_special_min/(12*0.9) revenu_special_min/(12*0.9)],[0 ord_impots(end)],'--r');
    plot([revenu_special_max/(12*0.9) revenu_special_max/(12*0.9)],[0 ord_impots(end)],'--r');
    plot([plafondC plafondC],[0 ord_impots(end)],'--r');
end
axis([abs_salaires(1) abs_salaires(end) ord_impots(1) ord_impots(end)])
% % Plot pour Pierre
% plot([1177.53 1177.53],[0 imposition(1177.53,invalide)],'r');
% plot([0 1177.53],[imposition(1177.53,invalide) imposition(1177.53,invalide)],'r');
% 
% % Plot pour Paul
% plot([1500 1500],[0 imposition(1500,invalide)],'r');
% plot([0 1500],[imposition(1500,invalide) imposition(1500,invalide)],'r');
% 
% % Plot pour Jacques
% plot([2000 2000],[0 imposition(2000,invalide)],'r');
% plot([0 2000],[imposition(2000,invalide) imposition(2000,invalide)],'r');

% Annotations de la figure
% Create xlabel
xlabel({'salaire mensuel net imposable (en euros)'},'FontSize',12);

% Create ylabel
ylabel({'impt sur le revenu mensuel (en euros)'},'FontSize',12);

if invalide
    % Create title
    title({'VARIATIONS DE L''IMPOT SUR LE REVENU POUR UNE PERSONNE INVALIDE (2015)'},...
    'Color',[1 0 0]);

    if 0
    % Create textbox
    annotation(figure1,'textbox',...
    [0.206357142857143 0.15 0.143642857142857 0.0357142857142861],...
    'String',{'Pierre'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[1 0 0]);

    % Create textbox
    annotation(figure1,'textbox',...
    [0.326357142857143 0.15 0.143642857142857 0.0357142857142861],...
    'String',{'Paul'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[1 0 0]);

    % Create textbox
    annotation(figure1,'textbox',...
    [0.251714285714286 0.283333333333333 0.107928571428572 0.0523809523809531],...
    'String',{'Jacques'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[1 0 0]);

    end 
    
    if 0

    % Create textbox
    annotation(figure1,'textbox',...
    [0.306714285714285 0.777619047619049 0.107928571428572 0.0523809523809531],...
    'String',{'TMI 0%'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0.498039215686275 0]);

     

     % Create textbox
    annotation(figure1,'textbox',...
    [0.658142857142856 0.781428571428573 0.116142857142858 0.0523809523809531],...
    'String',{'TMI 14%'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0.498039215686275 0]);

    end 
    
    if 1
        
        % Create textbox
    annotation(figure1,'textbox',...
    [0.156714285714285 0.777619047619049 0.107928571428572 0.0523809523809531],...
    'String',{'TMI 0%'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0.498039215686275 0]);

    % Create textbox
    annotation(figure1,'textbox',...
    [0.356714285714285 0.777619047619049 0.107928571428572 0.0523809523809531],...
    'String',{'TMI 14%'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0.498039215686275 0]);

     

     % Create textbox
    annotation(figure1,'textbox',...
    [0.608142857142856 0.781428571428573 0.116142857142858 0.0523809523809531],...
    'String',{'TMI 30%'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0.498039215686275 0]);

    end
    
    if 0

    % Create doublearrow
annotation(figure1,'doublearrow',[0.1375 0.591071428571429],...
    [0.389476190476191 0.390476190476191],'Color',[1 0 1]);

% Create textbox
annotation(figure1,'textbox',...
    [0.304571428571429 0.407142857142857 0.222214285714286 0.033333333333334],...
    'String',{'imposition nulle'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[1 0 1]);

% Create doublearrow
annotation(figure1,'doublearrow',[0.139285714285714 0.689285714285714],...
    [0.482333333333333 0.483333333333333],'Color',[0 0 1]);

% Create textbox
annotation(figure1,'textbox',...
    [0.315285714285714 0.492857142857143 0.315071428571429 0.0404761904761923],...
    'String',{'application de la dcte'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0 1]);

% Create doublearrow
annotation(figure1,'doublearrow',[0.139285714285714 0.467857142857143],...
    [0.679952380952381 0.680952380952381],'Color',[1 0 0]);

% Create textbox
annotation(figure1,'textbox',...
    [0.229571428571429 0.688095238095238 0.225785714285714 0.0500000000000022],...
    'String',{'abattement 2344'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[1 0 0]);

% Create doublearrow
annotation(figure1,'doublearrow',[0.491071428571429 0.685714285714286],...
    [0.679952380952381 0.678571428571429],'Color',[1 0 0]);

% Create textbox
annotation(figure1,'textbox',...
    [0.498214285714286 0.702380952380953 0.194642857142857 0.0357142857142856],...
    'String',{'abattement 1172'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[1 0 0]);

end
else
    % Create title
    title({'VARIATIONS DE L''IMPOT SUR LE REVENU POUR UNE PERSONNE VALIDE (2015)'},...
    'Color',[1 0 0]);
if 0
    % Create textbox
    annotation(figure1,'textbox',...
    [0.206357142857143 0.15 0.143642857142857 0.0357142857142861],...
    'String',{'Pierre'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[1 0 0]);

    % Create textbox
    annotation(figure1,'textbox',...
    [0.211714285714286 0.283333333333333 0.107928571428572 0.0523809523809531],...
    'String',{'Paul'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[1 0 0]);

    % Create textbox
    annotation(figure1,'textbox',...
    [0.198857142857142 0.444285714285715 0.107928571428572 0.0523809523809531],...
    'String',{'Jacques'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[1 0 0]);

    % Create textbox
    annotation(figure1,'textbox',...
    [0.206714285714285 0.777619047619049 0.107928571428572 0.0523809523809531],...
    'String',{'TMI 0%'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0.498039215686275 0]);
end

     % Create textbox
    annotation(figure1,'textbox',...
    [0.128142857142856 0.781428571428573 0.116142857142858 0.0523809523809531],...
    'String',{'TMI 0%'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0.498039215686275 0]);

     % Create textbox
    annotation(figure1,'textbox',...
    [0.258142857142856 0.781428571428573 0.116142857142858 0.0523809523809531],...
    'String',{'TMI 14%'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0.498039215686275 0]);

    % Create textbox
    annotation(figure1,'textbox',...
    [0.508142857142856 0.781428571428573 0.116142857142858 0.0523809523809531],...
    'String',{'TMI 30%'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0.498039215686275 0]);

    % Create textbox
    annotation(figure1,'textbox',...
    [0.801714285714285 0.779047619047621 0.107928571428572 0.0523809523809531],...
    'String',{'TMI 45%'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0.498039215686275 0]);

if 1

% Create doublearrow
annotation(figure1,'doublearrow',[0.130357142857143 0.45531914893617],...
    [0.563285714285714 0.563139931740614],'Color',[1 0 1]);

% Create textbox
annotation(figure1,'textbox',...
    [0.221428571428571 0.681878758329271 0.288829413829414 0.0580204778157001],...
    'String',{'application de la dcte'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[0 0 1]);

% Create doublearrow
annotation(figure1,'doublearrow',[0.1375 0.548214285714286],...
    [0.692889159759467 0.695238095238095],'Color',[0 0 1]);

% Create textbox
annotation(figure1,'textbox',...
    [0.217869954369955 0.566626036079961 0.199 0.0428571428571443],...
    'String',{'imposition nulle'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none',...
    'Color',[1 0 1]);
end

end

% Enregistrement de la courbe d'impt
save('x_salaires','abs_salaires');
if invalide
    save('y_impots_invalide','ord_impots');
else
    save('y_impots_valide','ord_impots');
end